
#ifndef WEB_GTKHTML2_H
#define WEB_GTKHTML2_H

#include "config.h"
#include <string.h>
#include <glib.h>
#include <libgtkhtml/gtkhtml.h>
#include "web.h"
#include "web_request.h"

typedef struct {
	WebPages *pages;
	gpointer js_runtime;
} WebGtkhtml2Data;

typedef struct {
	WebGtkhtml2Data *parent;
	WebData *data;
	HtmlView *view;
	HtmlDocument *document;
	
	/* Vars for CSS */
	GSList *sheets;
	
	/* Vars for JS */
	GSList *scripts;
	gpointer js_context;	/* JSContext * */
	gpointer js_global;	/* JSObject * */
	gpointer js_document;	/* JSObject * */
	gboolean do_jscript;
	GHashTable *js_objects;
	GList *js_events;
	GList *ext_js;
	DomNode *node;		/* Node that called the JS */
	gchar *inject;		/* For injecting into the document stream */
	gboolean stalling;	/* For stalling while fetching scripts */
	gboolean stalling_close;
	WebRequest *page_request;
	gchar *buffer;		/* For buffering while stalling */
	gint buffer_size;
} WebGtkhtml2PageData;

void web_gtkhtml2_print_dom (xmlNodePtr node, int depth);
void web_gtkhtml2_dom_foreach (DomNode *node, GFunc function,
			       gpointer user_data);
DomNode *web_gtkhtml2_dom_find (DomNode *node, GEqualFunc function,
				gpointer user_data);
void web_gtkhtml2_write (gpointer backend_data, gpointer page_data,
			 WebRequest *request, gchar *buffer, gint size);
void web_gtkhtml2_close (gpointer backend_data, gpointer page_data,
			 WebRequest *request);

#endif
